#!/bin/bash

echo -e ""
echo -e "\e[1;37mСегодня: $(date +%A\ %e\ %b\ %Yr.\ Терминал\ открыт\ в\ %H:%M)\e[0m"
echo -e "
\e[1;37mВы запустили программу для восстановления загрузчика grub2. Подробную информацию вы можете прочитать на Rosa Wiki (\e[0m" "\e[4;94mhttp://wiki.rosalab.ru/ru/index.php/%D0%92%D0%BE%D1%81%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BB%D0%B5%D0%BD%D0%B8%D0%B5_%D0%B7%D0%B0%D0%B3%D1%80%D1%83%D0%B7%D1%87%D0%B8%D0%BA%D0%B0_Grub2\e[0m" "\e[1;37m).
\e[0m"
echo -e ""
echo -e "\e[1;37mНиже отображены сведения о подключенных носителях информации\e[0m"
echo -e ""
echo -e "-------------------------------------------------------------------------------------------------------------------------------"
lsblk -f
echo -e "-------------------------------------------------------------------------------------------------------------------------------"
echo -e "\e[1;37mНужно ли вывести более подробную информацию по разделам?\e[0m"
echo ""
read -p "Если нужно нажмите "Y", если нет "N" " -n 1 -r
echo    # (optional) move to a new line
if [[ ! $REPLY =~ ^[Yy]$ ]]
then
    echo -e "-------------------------------------------------------------------------------------------------------------------------------"
else
    /sbin/fdisk -l
    echo -e ""
fi
echo -e ""

#-----------------------------------------------------------------------------------------------------------------------------------------------------------------
#----------------------------------------------------------Задаем корневой раздел и проверяем на swap и существование---------------------------------------------
echo -e "\e[1;31mВведите наименование раздела с корнем системы (/) sdXX. Вместо ХХ укажите свои значения\e[0m"
#lang=$(setxkbmap -print | sed -n 's#xkb_symbols[^"]*"\([^"]*\)".*$#\1#p' | awk -F+ '{print $2}') #Определение раскладки клавиатуры
fs=swap
d=0
sdxx=1

while [ "$fs" == "swap" ]  #Определяем является ли раздел swap
do
    read sdxx
    fs="$(lsblk -f | grep $sdxx | grep -o swap | sed -n 1p)" #sed -n 1p записывает только первую строчку из вывода
    if [ "$fs" == "swap" ]; then
        echo "Выбранный раздел является разделом подкачки(swap) или не соответствует корневому разделу."
        echo "Выберите другой раздел"
    else
        break
    fi
done

sd="$(echo "$sdxx" | cut -b 1-2)"
while [ "$sdxx" != "$d" ] || [ "$(expr length $sdxx)" != 4 ] || [ "$(/sbin/fdisk -l | grep $sdxx | grep -o EFI | sed -n 1p)" != "EFI" ] #Определяем является ли раздел существующим и uefi
do
    declare -a array #через массив определяем содержится ли введеный раздел в списке всех разделов
    array=($(ls /dev/ | grep "$sd"))
    for item in "${array[@]}"
    do
        if [[ $sdxx == "$item" ]]; then
            d="$item"
            sleep .1
            echo "Раздел $d найден в списке разделов"
            #sleep .1
            break
        else
            sleep .1
            echo "поиск $sdxx в списке разделов"
        fi
    done

    if [ "$sdxx" != "$d" ] || [ "$(expr length $sdxx)" != 4 ] || [ "$(/sbin/fdisk -l | grep $sdxx | grep -o EFI | sed -n 1p)" == "EFI" ]; then # проверяем является ли указанный раздел существующим
    #или uefi
        echo "Выбранный раздел отсутствует в списке разделов или не соответствует формату sdXX, или является uefi разделом."
        echo "Выберите другой раздел"
        fs=swap
        while [ "$fs" == "swap" ]  #Определяем является ли новый введенный раздел swap
        do
            read sdxx
            echo -e "\e[1;36mДля восстановления загрузчика grub2 выбран раздел\e[0m"  "\e[1;34m/dev/$sdxx\e[0m"
            fs="$(lsblk -f | grep $sdxx | grep -o swap | sed -n 1p)"
            if [ "$fs" == "swap" ] || [ "$(expr length $sdxx)" != 4 ]; then
                echo "Выбранный раздел является разделом подкачки(swap) и не соответствует корневому разделу."
                echo "Выберите другой раздел"
            else
                break
            fi
        done
    else
        break
    fi
done

#--------------------------------------------------------------------Конец задания корня и проверок---------------------------------------------------------------
#----------------------------------------------------------------------------------------------------------------------------------------------------------------- 

#-----------------------------------------------------------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------Выполняем восстановление Grub2 в btrfs или др. ФС---------------------------------------------------

sdx="$(echo "$sdxx" | cut -b 1-3)"
export $sdx
#задаем функцию tmpchroot для создания файла /chroot/tmp/chroot.sh
tmpchroot () {
cat << EOF > /chroot/tmp/chroot.sh
    #!/bin/bash
    echo -e "\e[1;92m==================Вход в /chroot==================\e[0m"
    sleep .1
    echo "Монтиррование всех записей из /chroot/etc/fstab "
    mount -a
    sleep .1
    echo "Установка grub2 на /dev/$sdx"
    grub2-install /dev/$sdx
    sleep .1
    echo "Обновление grub2"
    update-grub2
    sleep .1
    echo -e "\e[1;91m==================Выход из /chroot==================\e[0m"
    exit
EOF
}
fs=$(lsblk -f | grep $sdxx | grep -o "btrfs" | sed -n 1p)
#Проверяем соответствует ли ФС на разделе /dev/sdxx ФС btrfs. Если да, то восстановление загрузчика происходит немного иначе нежели чем с ФС без подтомов.
if [[ "$fs" == "btrfs" ]]; then #если система btrfs, то выполняем ниже
    echo -e "Файловая система $fs"
    echo ""
    echo -e "\e[1;31mЕсли вы используете подтома(subvole), то введите наименование подтома\e[0m \e[1;34mbtrfs\e[0m \e[1;31mсодержащего корень системы.\e[0m" "\e[1;31mНиже приведен список подтомов\e[0m \e[0m" "\e[1;34m/dev/$sdxx\e[0m"
    echo -e ""
    if [ ! -e "/tmp/grub2recovery/" ]; then # Если /tmp/grub2recovery/ не существует - создать.
        mkdir /tmp/grub2recovery/
    fi
    mount -r /dev/$sdxx /tmp/grub2recovery/
    echo -e "------------------------------------------------------------------"
    btrfs subvolume list /tmp/grub2recovery/
    echo -e "------------------------------------------------------------------"
    umount /tmp/grub2recovery/
    read subvol #ввод подтома btrfs
    if [ -z "$subvol" ]; then #здесь если введен пустой подтом, то выполняется восстановление Grub2 по схеме без подтомов.
        echo ""
        echo ""
        echo -e "\e[1;37m                Проверка введенных данных\e[0m"
        echo -e "_______________________________________________________________"
        echo -e " \e[1;36mДля восстановление загрузчика Grub2 выбран раздел\e[0m"  "\e[1;34m/dev/$sdxx\e[0m "
        echo -e " \e[1;36mФайловая система\e[0m"  "\e[1;34m$fs                                      \e[0m"
        echo -e "_______________________________________________________________"
        echo ""
        echo ""
        read -p "Для начала установки нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
        echo    # (optional) move to a new line
        if [[ ! $REPLY =~ ^[Yy]$ ]]; then
            echo "Отменено пользователем"
            sleep 0.5
            exit 0
        else
            echo -e "------------------------------------------------------------------"
            echo -e ""
        fi
        FILE=/chroot
        if [ -d "$FILE" ]; then #Проверяем существует ли каталог /chroot
            echo "Каталог $FILE уже существует. Создание не требуется."
        else
            echo "Создан каталог $FILE"
            mkdir /chroot
        fi
        mount /dev/$sdxx /chroot
        sleep .1
        echo "Каталог $sdxx примонтирован в каталог /chroot"
        for i in dev sys proc etc/resolv.conf; do mount --bind -v /$i /chroot/$i; done
        sleep .1
        tmpchroot #создаем файл /chroot/tmp/chroot.sh с помощью ранее заданной функции
        chmod 550 /chroot/tmp/chroot.sh
        chroot /chroot bash /tmp/chroot.sh
        sleep .1
        echo "Синхронизация"
        sync
        sleep .1
        echo "Восстановление загрузчика Grub2 завершено"
        read -p "Чтобы перезагрузить компьютер нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
        echo    # (optional) move to a new line
        if [[ ! $REPLY =~ ^[Yy]$ ]]; then
            rm /chroot/tmp/chroot.sh
            umount /chroot
            sleep 0.5
            exit 0
        else
            echo "Перезагрузка"
            sleep .5
            rm /chroot/tmp/chroot.sh
            umount /chroot
            reboot
        fi
    else #здесь начинается восстановление Grub2 если введен не пустой подтом btrfs по схеме с подтомами
        echo ""
        echo ""
        echo -e "\e[1;37m                Проверка введенных данных\e[0m"
        echo -e "_______________________________________________________________"
        echo -e " \e[1;36mДля восстановление загрузчика Grub2 выбран раздел\e[0m"  "\e[1;34m/dev/$sdxx\e[0m "
        echo -e " \e[1;36mФайловая система\e[0m"  "\e[1;34m$fs                                      \e[0m"
        echo -e " \e[1;36mВ качестве корневого подтомы выбран подтом\e[0m"  "\e[1;34m$subvol                \e[0m"
        echo -e "_______________________________________________________________"
        echo ""
        echo ""
        read -p "Для начала установки нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
        echo    # (optional) move to a new line
        if [[ ! $REPLY =~ ^[Yy]$ ]]; then
            echo "Отменено пользователем"
            sleep 0.5
            exit 0
        else
            echo -e "------------------------------------------------------------------"
            echo -e ""
        fi
        FILE=/chroot
        if [ -d "$FILE" ]; then #Проверяем существует ли каталог /chroot
            echo "Каталог $FILE уже существует. Создание не требуется."
        else
            echo "Создан каталог $FILE"
            mkdir /chroot
        fi
        mount -o subvol=$subvol /dev/$sdxx /chroot
        sleep .1
        echo "Подтом $subvol примонтирован в каталог /chroot"
        for i in dev sys proc etc/resolv.conf; do mount --bind -v /$i /chroot/$i; done
        sleep .1
        tmpchroot #создаем файл /chroot/tmp/chroot.sh с помощью ранее заданной функции
        chmod 550 /chroot/tmp/chroot.sh
        chroot /chroot bash /tmp/chroot.sh
        sleep .1
        echo "Синхронизация"
        sync
        sleep .1
        echo "Восстановление загрузчика Grub2 завершено"
        read -p "Чтобы перезагрузить компьютер нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
        echo    # (optional) move to a new line
        if [[ ! $REPLY =~ ^[Yy]$ ]]; then
            rm /chroot/tmp/chroot.sh
            umount /chroot
            sleep 0.5
            exit 0
        else
            echo "Перезагрузка"
            sleep .5
            rm /chroot/tmp/chroot.sh
            umount /chroot
            reboot
        fi
    fi
else #здесь выполняется восстановление Grub2 если система не btrfs
    fs="$(blkid | grep $sdxx)" #записываем вывод с выбранным разделом
    fsx=$(echo ${fs#*TYPE=} | cut -b 1-6) #задаем в переменную со 2 по 6 символ после слова TYPE
    echo ""
    echo ""
    echo -e "\e[1;37m                Проверка введенных данных\e[0m"
    echo -e "_______________________________________________________________"
    echo -e " \e[1;36mДля восстановление загрузчика Grub2 выбран раздел\e[0m"  "\e[1;34m/dev/$sdxx\e[0m "
    echo -e " \e[1;36mФайловая система\e[0m"  "\e[1;34m$fsx                                     \e[0m"
    echo -e "_______________________________________________________________"
    echo ""
    echo ""
    read -p "Для начала установки нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
    echo    # (optional) move to a new line
    if [[ ! $REPLY =~ ^[Yy]$ ]]; then
        echo "Отменено пользователем"
        sleep 0.5
        exit 0
    else
        echo -e "------------------------------------------------------------------"
        echo -e ""
    fi
    FILE=/chroot
    if [ -d "$FILE" ]; then #Проверяем существует ли каталог /chroot
        echo "Каталог $FILE уже существует. Создание не требуется."
    else
        echo "Создан каталог $FILE"
        mkdir /chroot
    fi
    mount /dev/$sdxx /chroot
    sleep .1
    echo "Раздел /dev/$sdxx примонтирован в каталог /chroot"
    for i in dev sys proc etc/resolv.conf; do mount --bind -v /$i /chroot/$i; done
    sleep .1
    tmpchroot #создаем файл /chroot/tmp/chroot.sh с помощью ранее заданной функции
    chmod 550 /chroot/tmp/chroot.sh
    chroot /chroot bash /tmp/chroot.sh
    sleep .1
    echo "Синхронизация"
    sync
    sleep .1
    echo "Восстановление загрузчика Grub2 завершено"
    read -p "Чтобы перезагрузить компьютер нажмите "Y", для закрытия программы нажмите "N" " -n 1 -r
    echo    # (optional) move to a new line
    if [[ ! $REPLY =~ ^[Yy]$ ]]; then
        rm /chroot/tmp/chroot.sh
        umount /chroot
        sleep 0.5
        exit 0
    else
        echo "Перезагрузка"
        sleep .5
        rm /chroot/tmp/chroot.sh
        umount /chroot
        reboot
    fi
fi
#-------------------------------------------------------------Конец восстановления Grub2 в btrfs или др. ФС---------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------------------------------------------------
